Program MID2;

Uses
 Crt,MidiFile,Midi,AdlibGM;

{$DEFINE Tracks}
{$DEFINE Graph}

Const
 IName:array[0..127] of PChar=(
  'Acoustic Grand',
  'Bright Acoustic',
  'Electric Grand',
  'Honky-Tonk',
  'Electric Piano 1',
  'Electric Piano 2',
  'Harpsichord',
  'Clav',
  'Celesta',
  'Glockenspiel',
  'Music Box',
  'Vibraphone',
  'Marimba',
  'Xylophone',
  'Tubular Bells',
  'Dulciner',

  'Drawbar Organ',
  'Percussive Organ',
  'Rock Organ',
  'Church Organ',
  'Reed Organ',
  'Accordian',
  'Harmonica',
  'Tango Accordian',
  'Acoustic Guitar (nylon)',
  'Acoustic Guitar (Steel)',
  'Electric Guitar (Jazz)',
  'Electric Guitar (clean)',
  'Electric Guitar (muted)',
  'Overdriven Guitar',
  'Distortion Guitar',
  'Guitar Harmonics',

  'Acoustic Bass',
  'Electric Bass (finger)',
  'Electric Bass (pick)',
  'Fretless Bass',
  'Slap Bass 1',
  'Slap Bass 2',
  'Synth Bass 1',
  'Synth Bass 2',
  'Violin',
  'Viola',
  'Cello',
  'Contrabass',
  'Tremolo Strings',
  'Pizzicato Strings',
  'Orchestral Strings',
  'Timpani',

  'String Ensemble 1',
  'String Ensemble 2',
  'SynthStrings 1',
  'SynthStrings 2',
  'Choir ("Aahs")',
  'Voice ("Oohs")',
  'Synth Voice',
  'Orchestra Hit',
  'Trumpet',
  'Trombone',
  'Tuba',
  'Muted Trumpet',
  'French Horn',
  'Brass Section',
  'SynthBrass 1',
  'SynthBrass 2',

  'Soprano Sax',
  'Alto Sax',
  'Tenor Sax',
  'Baritone Sax',
  'Oboe',
  'English Horn',
  'Bassoon',
  'Clarinet',
  'Piccolo',
  'Flute ',
  'Recorder',
  'Pan Flute',
  'Blown Bottle',
  'Shakuhachi',
  'Whistle',
  'Ocarina',

  'Lead 1 (square)',
  'Lead 2 (sawtooth)',
  'Lead 3 (calliope)',
  'Lead 4 (Chiff)',
  'Lead 5 (Charang)',
  'Lead 6 (Voice)',
  'Lead 7 (fifths)',
  'Lead 8 (bass+lead)',
  'Pad 1 (new age)',
  'Pad 2 (warm)',
  'Pad 3 (Polysynth)',
  'Pad 4 (Choir)',
  'Pad 5 (Bowed)',
  'Pad 6 (Mtallic)',
  'Pad 7 (Halo)',
  'Pad 8 (Sweep)',

  'FX 1 (rain)',
  'FX 2 (Soundtrack)',
  'FX 3 (Cristal)',
  'FX 4 (Atmosphere)',
  'FX 5 (Brightness)',
  'FX 6 (Goblins)',
  'FX 7 (Echoes)',
  'FX 8 (Sci-fi)',
  'Sitar',
  'Banjo',
  'Shamisen',
  'Koto',
  'Kalimba',
  'Bagpipe',
  'Fiddle',
  'Shanai',

  'Tinkle Bell',
  'Agogo',
  'Steel Drums',
  'Woodblock',
  'Taiko Drum',
  'Melodic Tom',
  'Synth Drum',
  'Reverse Cymbal',
  'Guitar Fret Noise',
  'Breath Noise',
  'Seashore',
  'Bird Tweet',
  'Telephone Ring',
  'Helicopter',
  'Applause',
  'Gunshot'
 );
Var
 T       :Word;
 Wait    :longint;
 Event   :byte;
 Channel :byte;
 Note    :byte;
 Velocity:byte;
 Meta    :byte;
 MetaSize:word;

 Time    :longint;

 b:byte;

 s:string;

 Dly:longint;

 gy:word;
 go:word;
 x,y:word;

Const
 Hexa:array[0..$F] of char='0123456789ABCDEF';

Function DelayCount:longint;
 Var
  Count:longint;
  t:integer;
 begin
  t:=1;
  while t<=TrackCount do begin
   Count:=Tracks^[t].Timer;
   if Count>=0 then break;
   inc(t);
  end;
  while t<=TrackCount do begin
   with Tracks^[T] do if (Timer>=0)and(Timer<Count) then Count:=Timer;
   inc(t);
  end;
  DelayCount:=Count;
 end;

Procedure WriteTime;
 var
  hh,mm,ss,ms:word;
 begin
  Inc(Time,(Wait*Tempo) div Ticks);
  ss:=Time div 1000;
  ms:=Time mod 1000;
  mm:=ss div 60; ss:=ss mod 60;
  hh:=mm div 60; mm:=mm mod 60;
  write('0',hh,':');
  if mm<10 then write('0');
  write(mm,':');
  if ss<10 then write('0');
  write(ss,'.');
  if ms<100 then write('0');
  if ms<10 then write('0');
  writeln(ms);
 end;

Procedure WriteNote(Note:byte);
 Const
  Notes:array[0..11] of String[2]=(
   'C ','C#','D ','D#','E ','F ','F#','G ','G#','A ','A#','B '
  );
 begin
  Write(Notes[Note mod 12],Note div 12);
 end;

Procedure PlayLoop;
 begin
  Wait:=DelayCount;

  While Wait>=0 do begin

  Dly:=((Wait*Tempo) div Ticks);
  ClrEol; WriteLn('Delay ',Dly);
  if Dly>0 then Delay(Dly);
  GotoXY(1,3);
  WriteLn('Tempo = ',Tempo);
  WriteTime;

  for T:=1 to MidiFile.TrackCount do

   With MidiFile.Tracks^[T] do begin
   {$IFDEF TRACKS}
    Write('Track #',T:3,', ');
   {$ENDIF}
    if Timer>0 then Dec(Timer,Wait);
   {$IFDEF TRACKS}
    if Timer<0 then begin ClrEOL; WriteLn('done.') end else

    if Timer>0 then WriteLn{('wait ',Timer)} else
   {$ELSE}
    If Timer=0 then
   {$ENDIF}
    begin
     ClrEOL;

     Event:=Data^[Index];
     if Event<$80 then Event:=Last else begin Last:=Event; Inc(Index); end;

     Case Event shr 4 of

      $8: begin {Note Off }
           Channel :=Event and $F;
           Note    :=Data^[Index]; inc(index);
           Velocity:=Data^[Index]; inc(index);
           NoteOff(Channel,Note,Velocity);
          {$IFDEF TRACKS}
           Write('Note off : Channel ',Channel,' ');
           WriteNote(Note);
           Writeln(',',Velocity:3);
          {$ENDIF}
          {$IFDEF Graph}
           go:=160*(gy+Channel)+(Note and $FE)+3;
           if odd(note) then
            Mem[SegB800:go]:=(Mem[SegB800:go] - $01)
           else
            Mem[SegB800:go]:=(Mem[SegB800:go] - $10);
          {$ENDIF}
          end;

      $9: begin {Note On }
           Channel :=Event and $F;
           Note    :=Data^[Index]; inc(index);
           Velocity:=Data^[Index]; inc(index);
           if Velocity=0 then
            NoteOff(Channel,Note,Velocity)
           else
            NoteOn(Channel,Note,Velocity);
          {$IFDEF TRACKS}
           Write('Note ');
           if Velocity=0 then Write('off') else write('on ');
           write(' : Channel ',Channel,' ');
           WriteNote(Note);
           writeln(',',Velocity:3,' ',IName[Instrs[Channel]]);
          {$ENDIF}
          {$IFDEF Graph}
           go:=160*(gy+Channel)+(Note and $FE)+3;
           if Velocity>0 then begin

            if odd(note) then
             Mem[SegB800:go]:=(Mem[SegB800:go] + $01)
            else
             Mem[SegB800:go]:=(Mem[SegB800:go] + $10);

           end else begin

            if odd(note) then
             Mem[SegB800:go]:=(Mem[SegB800:go] - $01)
            else
             Mem[SegB800:go]:=(Mem[SegB800:go] - $10);

           end;
          {$ENDIF}
          end;

      $A: begin { Key Aftertouch - only supported for GM device }
           Channel :=Event and $F;
           Note    :=Data^[Index]; inc(index);
           Velocity:=Data^[Index]; inc(index);
           SetVolume(Channel,Note,Velocity);
          {$IFDEF TRACKS}
           Write('Key aftertouch : Channel ',Channel,' ');
           WriteNote(Note);
           Writeln(',',Velocity:3);
          {$ENDIF}
          end;

      $B: begin { Control change - only supported for GM device }
          {$IFDEF TRACKS}
           Write('Control change : ');
           case Data^[Index] of
            $66:writeln('Music marker');
            $67:writeln('Percussion mode');
            $68:writeln('All note upward');
            $69:writeln('All note downward');
            else writeln(Data^[Index]);
           end;
          {$ENDIF}
           Inc(Index,2);
          end;

      $C: begin { Patch change - this changes the instrument on a channel }
           Channel:=Event and $F;
           Instrs[Channel]:=Data^[Index]; inc(Index);
          {$IFDEF TRACKS}
           WriteLn('Patch change ',Channel,': ',IName[Instrs[Channel]]);
          {$ENDIF}
          end;

      $D: begin { Channel aftertouch - only supported on GM device }
           Inc(Index);
          {$IFDEF TRACKS}
           WriteLn('Channel aftertouch (?)');
          {$ENDIF}
          end;

      $E: begin { Pitch wheel change - only supported on GM device }
           Inc(Index,2);
          {$IFDEF TRACKS}
           WriteLn('Pitch wheel change (?)');
          {$ENDIF}
          end;

      $F: begin
          {$IFDEF TRACKS}
           Write('META-');
          {$ENDIF}
           Meta:=Data^[Index]; inc(Index);

           MetaSize:=0;
           Repeat
            b:=Data^[Index]; inc(index);
            MetaSize:=MetaSize shl 7 + (b and $7f);
           Until b<128;

           Case Meta of
            $00: begin;
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Unknow 00 : "',s,'"');
                 {$ENDIF};
                 end;
            $01: begin;
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Unknow 01 : "',s,'"');
                 {$ENDIF};
                 end;
            $02: begin { Copyright }
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Copyright : "',s,'"');
                 {$ENDIF};
                 end;
            $03: begin { Track Name }
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Track name : "',s,'"');
                 {$ENDIF}
                 end;
            $04: begin { Instrument Name }
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Instrument name : "',s,'"');
                 {$ENDIF}
                 end;
            $06: begin { Marker }
                 {$IFDEF TRACKS}
                  s[0]:=Chr(MetaSize);
                  Move(Data^[Index],s[1],MetaSize);
                  Writeln('Marker : "',s,'"');
                 {$ENDIF}
                 end;
            $0A: begin;
                 {$IFDEF TRACKS}
                  Writeln('Unknow 0A');
                 {$ENDIF};
                 end;
            $20: {$IFDEF TRACKS}WriteLn('Unknow meta 20'){$ENDIF};
            $21: {$IFDEF TRACKS}Writeln('Track Start'){$ENDIF};
            $2F: begin
                  Index:=Size;
                 {$IFDEF TRACKS}
                  WriteLn('End of Track');
                 {$ENDIF}
                 end;
            $51: begin
                  Tempo:=(longint(Data^[Index+0]) shl 16
                         +word(Data^[Index+1]) shl 8
                         +Data^[Index+2]
                         ) div 1000;
                 {$IFDEF TRACKS}
                  WriteLn('Change Tempo (',Tempo,')');
                 {$ENDIF}
                 end;
            $54: {$IFDEF TRACKS}WriteLn('Unknow Meta 54'){$ENDIF};
            $58: {$IFDEF TRACKS}WriteLn('Time Signature (?)'){$ENDIF};
            $59: {$IFDEF TRACKS}Writeln('Key Signature (?)'){$ENDIF};
            $7F: {$IFDEF TRACKS}WriteLn('Unknow Meta 7F'){$ENDIF};
            else begin
             WriteLn('Unknow Meta '+Hexa[Meta shr 4]+Hexa[Meta and $F]);
             Halt;
            end;
           end;
           Inc(Index,MetaSize);
          end;

      else begin
            WriteLn('Unknow event #',Event);
            Halt;
           end;
     end;

     if Index>=Size then
      Timer:=-1
     else begin
      Timer:=0;
      Repeat
       b:=Data^[Index]; Inc(Index);
       Timer:=Timer shl 7 + (b and $7F);
      Until b<128;
     end;

    end; { Timer=0 }

   end; { With Track^[T] }
   Wait:=DelayCount;

{   if readkey=#27 then halt; }
   if keypressed then break;

  end; { While Wait>=0 }

 end;

begin
 TextMode(CO80+Font8x8);

 WriteLn('MIDI Player');
 Midi.Init([drSpeaker]{drAll});

 if not MidiFile.Open(paramstr(1)) then exit;

 WriteLn('Ticks = ',MidiFile.Ticks);
 WriteLn('Tempo = ',Tempo);
 Time:=0; WriteTime;
{$IFDEF TRACKS}
 MidiFile.TrackInfo;
{$ENDIF}
{$IFDEF GRAPH}

 writeln;
 gy:=WhereY;
 write('   ');
 for x:=1 to 10 do begin
  write(x);
  for y:=0 to 5 do write(' ');
 end;

 writeln;
 for y:=0 to 16 do begin
  write(y:2,'[');
  TextAttr:=0;
  for x:=0 to 127 div 2 do write(#222);
  TextAttr:=$07;
  writeln(']');
 end;
 GotoXY(1,gy-2);
{$ENDIF}

 PlayLoop;

 if ReadKey=#0 then ReadKey;

 Midi.Done;

 WriteLn('Done.');

 MidiFile.Close;
end.