Unit MidiSPK;
{$DEFINE SIMPE}
Interface

Procedure Reset;
procedure Done;
procedure NoteOff(Channel,Note,Velocity:word);
procedure NoteOn (Channel,Note,Velocity:word);
procedure SetVolume(Channel,Note,Velocity:word);

Implementation

Const
 mm=1;
 dd=1;
 ou=1;
 od=1;
 C     =  (((mm * 2093) div dd) shl ou) shr od;
 C_    =  (((mm * 2217) div dd) shl ou) shr od;
 D     =  (((mm * 2349) div dd) shl ou) shr od;
 D_    =  (((mm * 2489) div dd) shl ou) shr od;
 E     =  (((mm * 2637) div dd) shl ou) shr od;
 F     =  (((mm * 2794) div dd) shl ou) shr od;
 F_    =  (((mm * 2960) div dd) shl ou) shr od;
 G     =  (((mm * 3136) div dd) shl ou) shr od;
 G_    =  (((mm * 3322) div dd) shl ou) shr od;
 A     =  (((mm * 3520) div dd) shl ou) shr od;
 A_    =  (((mm * 3729) div dd) shl ou) shr od;
 H     =  (((mm * 3951) div dd) shl ou) shr od;
 Notes:array[0..11] of word=(
  C,C_,D,D_,E,F,F_,G,G_,A,A_,H
 );

 DrumChannels=[9]; { 10 ? 9..10 ? ????? }

Var
 TotalFreq:longint;
 NoteCount:longint;
 Channels:array[0..15,0..127] of record Freq,Vol:word end;

procedure StartSound( hertz : word); Assembler;
{hertz is the sound frequency to send to the speaker port}
asm
  MOV    BX,SP
  MOV    BX,&hertz
  MOV    AX,34DDh
  MOV    DX,0012h
  CMP    DX,BX
  JNB    @J1
  DIV    BX
  MOV    BX,AX
  IN     AL,61h
  TEST   AL,03h
  JNZ    @J2
  OR     AL,03h
  OUT    61h,AL
  MOV    AL,-4Ah
  OUT    43h,AL
@J2:
  MOV    AL,BL
  OUT    42h,AL
  MOV    AL,BH
  OUT    42h,AL
@J1:
end;

procedure nosound; Assembler;
{turns the speaker off}
asm
  IN     AL,61h
  AND    AL,0FCh
  OUT    61h,AL
end;

Procedure Reset;
 begin
  NoteCount:=0;
  FillChar(Channels,SizeOf(Channels),0);
  NoSound;
 end;

procedure Done;
 begin
  NoSound;
 end;

procedure PlayNote(f,v:word);
 var
  c,n:word;
 begin
  if NoteCount=0 then
   NoSound
  else begin
   for c:=0 to 15 do
    for n:=0 to 127 do
     with Channels[c,n] do begin
      if (f>0)and(Vol>v) then begin
       v:=Vol;
       f:=Freq;
      end;
     end;
   StartSound(f);
  end;
 end;

procedure NoteOn (Channel,Note,Velocity:word);
 Var
  F,O:word;
 begin
  F:=Notes[Note mod 12];
  O:=Note div 12;
  if O>4 then F:=F shl (O-4) else
  if O<4 then F:=F shr (4-O);
 {$IFDEF SIMPLE}
  StartSound(F);
 {$ELSE}
  O:=Channels[Channel,Note].Freq;
  Channels[Channel,Note].Freq:=F;
  NoSound;
  if F=0 then begin
   if O>0 then begin
    dec(TotalFreq,O);
    dec(NoteCount);
   end;
  end else begin
   inc(TotalFreq,F-O);
   if O=0 then Inc(NoteCount);
  end;
  PlayNote(F,Channels[Channel,Note].Vol);
  {
  if NoteCount>0 then StartSound(F);{TotalFreq div NoteCount);}
 {$ENDIF}
 end;

procedure NoteOff(Channel,Note,Velocity:word);
 var
  F:word;
 begin
 {$IFDEF SIMPE}
  if not Channel in DrumChannels then NoSound;
 {$ELSE}
  F:=Channels[Channel,Note].Freq;
  if (F>0) then begin
   Dec(TotalFreq,F);
   Dec(NoteCount);
   Channels[Channel,Note].Freq:=0;
   PlayNote(0,0);
   {if NoteCount=0 then NoSound else StartSound(TotalFreq div NoteCount);}
  end;
 {$ENDIF}
 end;

procedure SetVolume(Channel,Note,Velocity:word);
 begin
  Channels[Channel,Note].Vol:=Velocity;
 {$IFNDEF SIMPLE}
  PlayNote(0,0);
 {$ENDIF}
 end;

end.