Unit Timer;

Interface

procedure StartTimer;
procedure StopTimer;

Const
 OnTimer:procedure=nil;

Implementation

Const
 TimerInt=8;
 freq=100;
 counter=$1234DD div freq;

Var
 Ticks:word;
 OldTimer:pointer;
 Busy:byte;

procedure TimerHandler; interrupt; assembler;
 asm
  add ticks,counter
  jnc @not_now
   pushf
   call oldTimer
   jmp @done
  @not_now:
   mov dx,$20
   mov al,dl
   out dx,al
  @done:
  cmp busy,0
  jne @Skip
   mov busy,1
   call OnTimer
   mov busy,0
  @Skip:
 end;

procedure StartTimer; assembler;
 asm
  mov Ticks,0

  cmp word(OnTimer+2),0
  jz  @Done

  mov busy,0

 push ds                  { set new Timer }
  mov ax,cs
  mov ds,ax
  mov dx,offset TimerHandler
  mov ax,2500h + TimerInt
  int 21h
 pop  ds

  mov dx,$43   { setup timer }
  mov al,$34
  out dx,al

  mov dx,$40
  mov ax,Counter
  out dx,al
  mov al,ah
  out dx,al

 @Done:
 end;

procedure StopTimer; assembler;
 asm
  mov dx,$43    { reset timer }
  mov al,$34
  out dx,al

  mov dx,$40
  xor al,al
  out dx,al
  out dx,al

  push ds        { restore Timer }
   lds dx,OldTimer
   mov ax,2500h + TimerInt
   int 21h
  pop  ds
 end;


begin
 asm
  mov ax,3500h + TimerInt { get old Timer }
  int 21h
  mov word(OldTimer+0),bx
  mov word(OldTimer+2),es
 end;
end.