program XMID;

const
 out:string='XMID00.MID';

type
 TChunk=record
  Sign:Array[1..4] of char;
  Size:record Hi:Word; Lo:Word end;
 end;

 THeader=record
  SMF   :word;
  Tracks:word;
  Times :word;
 end;

var
 f:file;
 m:file;
 index:longint;
 buffer:string;

 Chunk:TChunk;
 ChunkSize:word;
 ChunkData:pointer;
 TrackCount:word;

 count:word;

Function ReadChunk(Sign:string):boolean;
 begin
  BlockRead(f,Chunk,SizeOf(Chunk));
  ReadChunk:=(Chunk.Sign=Sign)and(Chunk.Size.Hi=0);
  ChunkSize:=Swap(Chunk.Size.Lo);
 end;

Procedure GetChunk;
 begin
  GetMem(ChunkData,ChunkSize);
  BlockRead(f,ChunkData^,ChunkSize);
 end;

procedure outmidi;
 begin
  if not ReadChunk('MThd') then begin
   writeln('internal error 0');
   halt;
  end;
  blockwrite(m,Chunk,SizeOf(Chunk));
  GetChunk;
  blockwrite(m,ChunkData^,ChunkSize);
  With THeader(ChunkData^) do begin
   TrackCount:=Swap(Tracks);
  end;
  FreeMem(ChunkData,ChunkSize);
  while TrackCount>0 do begin
   ReadChunk('MTrk');
   blockwrite(m,Chunk,SizeOf(Chunk));
   GetChunk;
   blockwrite(m,ChunkData^,ChunkSize);
   FreeMem(ChunkData,ChunkSize);
   dec(TrackCount);
  end;
 end;

function fill:boolean;
 var
  i:integer;
 begin
  fill:=false;
  if eof(f) then exit;
  i:=length(buffer)+1;
  inc(index,i-1);
  if i>1 then begin
   delete(buffer,1,i-4);
   dec(i,4);
  end;
  blockread(f,buffer[i],SizeOf(buffer)-i,i);
  inc(buffer[0],i);
  fill:=true;
 end;

function locateHeader:boolean;
 var
  p:integer;
 begin
  buffer:='';
  index:=filepos(f);
  locateheader:=false;
  fill;
  p:=pos('MThd',buffer);
  while (p=0)and(fill) do p:=pos('MThd',buffer);
  if p=0 then
   locateheader:=false
  else begin
   locateheader:=true;
   seek(f,index+p-1);
  end;
 end;

begin
 assign(f,paramstr(1)); reset(f,1);
 index:=0;
 count:=0;
 while LocateHeader do begin
  assign(m,out);
  rewrite(m,1);
  inc(count);
  outmidi;
  close(m);
  if out[6]<'9' then
   inc(out[6])
  else begin
   out[6]:='0';
   inc(out[5]);
  end;
 end;
 close(f);
 writeln(count,' midi file(s) found');
end.